diff -r f6ef988fda71 trytond/model/model.py
--- a/trytond/model/model.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/model/model.py	Sun Sep 23 17:30:03 2012 +0200
@@ -487,78 +478,78 @@
                         'readonly' in res[field]['states']:
                     del res[field]['states']['readonly']
             for arg in ('digits', 'invisible'):
-                if hasattr(self._columns[field], arg) \
-                        and getattr(self._columns[field], arg):
-                    res[field][arg] = copy.copy(getattr(self._columns[field],
+                if hasattr(cls._fields[field], arg) \
+                        and getattr(cls._fields[field], arg):
+                    res[field][arg] = copy.copy(getattr(cls._fields[field],
                         arg))
-            if isinstance(self._columns[field],
+            if isinstance(cls._fields[field],
                     (fields.Function, fields.One2Many)) \
-                    and not self._columns[field].order_field:
+                    and not cls._fields[field].order_field:
                 res[field]['sortable'] = False
-            if ((isinstance(self._columns[field], fields.Function)
-                    and not self._columns[field].searcher)
-                    or self._columns[field]._type in ('binary', 'sha')):
+            if ((isinstance(cls._fields[field], fields.Function)
+                    and not cls._fields[field].searcher)
+                    or cls._fields[field]._type in ('binary', 'sha')):
                 res[field]['searchable'] = False
             else:
                 res[field]['searchable'] = True
 
             if Transaction().context.get('language'):
                 # translate the field label
-                res_trans = translation_obj.get_source(
-                        self._name + ',' + field, 'field',
-                        Transaction().context['language'])
+                res_trans = Translation.get_source(
+                    cls.__name__ + ',' + field, 'field',
+                    Transaction().context['language'])
                 if res_trans:
                     res[field]['string'] = res_trans
-                help_trans = translation_obj.get_source(
-                        self._name + ',' + field, 'help',
-                        Transaction().context['language'])
+                help_trans = Translation.get_source(
+                    cls.__name__ + ',' + field, 'help',
+                    Transaction().context['language'])
                 if help_trans:
                     res[field]['help'] = help_trans
 
-            if hasattr(self._columns[field], 'selection'):
-                if isinstance(self._columns[field].selection, (tuple, list)):
-                    sel = copy.copy(self._columns[field].selection)
+            if hasattr(cls._fields[field], 'selection'):
+                if isinstance(cls._fields[field].selection, (tuple, list)):
+                    sel = copy.copy(cls._fields[field].selection)
                     if Transaction().context.get('language') and \
-                            ((hasattr(self._columns[field],
+                            ((hasattr(cls._fields[field],
                                 'translate_selection') \
-                                and self._columns[field].translate_selection) \
-                                or not hasattr(self._columns[field],
+                                and cls._fields[field].translate_selection) \
+                                or not hasattr(cls._fields[field],
                                     'translate_selection')):
                         # translate each selection option
                         sel2 = []
                         for (key, val) in sel:
-                            val2 = translation_obj.get_source(
-                                    self._name + ',' + field, 'selection',
-                                    language, val)
+                            val2 = Translation.get_source(
+                                cls.__name__ + ',' + field, 'selection',
+                                language, val)
                             sel2.append((key, val2 or val))
                         sel = sel2
                     res[field]['selection'] = sel
                 else:
                     # call the 'dynamic selection' function
                     res[field]['selection'] = copy.copy(
-                            self._columns[field].selection)
+                            cls._fields[field].selection)
             if res[field]['type'] in (
                     'one2many',
                     'many2many',
                     'many2one',
                     'one2one',
                     ):
-                if hasattr(self._columns[field], 'model_name'):
-                    relation = copy.copy(self._columns[field].model_name)
+                if hasattr(cls._fields[field], 'model_name'):
+                    relation = copy.copy(cls._fields[field].model_name)
                 else:
                     relation = copy.copy(
-                        self._columns[field].get_target()._name)
+                        cls._fields[field].get_target().__name__)
                 res[field]['relation'] = relation
-                res[field]['domain'] = copy.copy(self._columns[field].domain)
-                res[field]['context'] = copy.copy(self._columns[field].context)
+                res[field]['domain'] = copy.copy(cls._fields[field].domain)
+                res[field]['context'] = copy.copy(cls._fields[field].context)
                 res[field]['create'] = fcreate_accesses.get(field, True)
                 res[field]['delete'] = fdelete_accesses.get(field, True)
             if res[field]['type'] == 'one2many' \
-                    and hasattr(self._columns[field], 'field'):
+                    and hasattr(cls._fields[field], 'field'):
                 res[field]['relation_field'] = copy.copy(
-                        self._columns[field].field)
+                        cls._fields[field].field)
             if res[field]['type'] in ('datetime', 'time'):
-                res[field]['format'] = copy.copy(self._columns[field].format)
+                res[field]['format'] = copy.copy(cls._fields[field].format)
 
             # convert attributes into pyson
             for attr in ('states', 'domain', 'context', 'digits', 'size',
@@ -573,9 +564,128 @@
                     del res[i]
         return res
 
-    def on_change_with(self, fieldnames, values):
+    def on_change_with(self, fieldnames):
         changes = {}
         for fieldname in fieldnames:
-            changes[fieldname] = getattr(self,
-                'on_change_with_%s' % fieldname)(values)
+            method_name = 'on_change_with_%s' % fieldname
+            changes[fieldname] = getattr(self, method_name)()
         return changes
+
+    def __init__(self, id=None, **kwargs):
+        super(Model, self).__init__()
+        if id is not None:
+            id = int(id)
+        self.__dict__['id'] = id
+        self._values = None
+        parent_values = {}
+        for name, value in kwargs.iteritems():
+            if not name.startswith('_parent_'):
+                setattr(self, name, value)
+            else:
+                parent_values[name] = value
+        for name, value in parent_values.iteritems():
+            parent_name, field = name.split('.', 1)
+            parent_name = parent_name[8:]  # Strip '_parent_'
+            parent = getattr(self, parent_name, None)
+            if parent is not None:
+                setattr(parent, field, value)
+            else:
+                setattr(self, parent_name, {field: value})
+
+    def __getattr__(self, name):
+        if name == 'id':
+            return self.__dict__['id']
+        if (name not in self._fields
+                and name not in self._inherit_fields):
+            # Search for method on inherits parents
+            pool = Pool()
+            for model_name, _ in self._inherits.iteritems():
+                iModel = pool.get(model_name)
+                if isinstance(getattr(iModel, name, None),
+                        collections.Callable):
+                    for cls in iModel.__mro__:
+                        if name in cls.__dict__:
+                            # Return a method bounded to current class
+                            return cls.__dict__[name].__get__(self,
+                                self.__class__)
+        elif self._values and name in self._values:
+            return self._values.get(name)
+        raise AttributeError("'%s' Model has no attribute '%s': %s"
+            % (self.__name__, name, self._values))
+
+    def __setattr__(self, name, value):
+        if name == 'id':
+            self.__dict__['id'] = value
+            return
+        if (name not in self._fields
+                and name in self._inherit_fields):
+            field = self._inherit_fields[name][2]
+            field.__set__(self, value)
+            return
+        super(Model, self).__setattr__(name, value)
+
+    def __getitem__(self, name):
+        warnings.warn('Use __getattr__ instead of __getitem__',
+            DeprecationWarning, stacklevel=2)
+        return getattr(self, name)
+
+    def __contains__(self, name):
+        return (name in self._fields
+            or name in self._inherit_fields)
+
+    def __int__(self):
+        return int(self.id)
+
+    def __str__(self):
+        return '%s,%s' % (self.__name__, self.id)
+
+    def __unicode__(self):
+        return u'%s,%s' % (self.__name__, self.id)
+
+    def __repr__(self):
+        if self.id < 0:
+            return "Pool().get('%s')(**%s)" % (self.__name__,
+                repr(self._default_values))
+        else:
+            return "Pool().get('%s')(%s)" % (self.__name__, self.id)
+
+    def __eq__(self, other):
+        if not isinstance(other, Model):
+            return NotImplemented
+        if self.id is None or other.id is None:
+            return False
+        return (self.__name__, self.id) == (other.__name__, other.id)
+
+    def __ne__(self, other):
+        if not isinstance(other, Model):
+            return NotImplemented
+        if self.id is None or other.id is None:
+            return True
+        return (self.__name__, self.id) != (other.__name__, other.id)
+
+    def __hash__(self):
+        return hash((self.__name__, self.id))
+
+    def __nonzero__(self):
+        return True
+
+    @property
+    def _default_values(self):
+        if self.id >= 0:
+            return self.id
+        values = {}
+        if self._values:
+            for fname, value in self._values.iteritems():
+                if fname in self._fields:
+                    field = self._fields[fname]
+                else:
+                    field = self._inherit_fields[fname][2]
+                if isinstance(field, fields.Reference):
+                    if value is not None:
+                        value = str(value)
+                elif isinstance(value, Model):
+                    value = value._default_values
+                elif isinstance(value, list):
+                    value = [r._default_values for r in value]
+                values[fname] = value
+        return values
diff -r f6ef988fda71 trytond/model/modelsingleton.py
--- a/trytond/model/modelsingleton.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/model/modelsingleton.py	Sun Sep 23 17:30:03 2012 +0200
@@ -8,98 +8,87 @@
     Define a singleton model in Tryton.
     """
 
-    def get_singleton_id(self):
+    @classmethod
+    def get_singleton(cls):
         '''
-        Return the id of the unique record if there is one.
+        Return the instance of the unique record if there is one.
         '''
-        singleton_ids = super(ModelSingleton, self).search([], limit=1)
-        if singleton_ids:
-            return singleton_ids[0]
-        return False
+        singletons = super(ModelSingleton, cls).search([], limit=1)
+        if singletons:
+            return singletons[0]
 
-    def create(self, values):
-        singleton_id = self.get_singleton_id()
-        if singleton_id:
-            self.write(singleton_id, values)
+    @classmethod
+    def create(cls, values):
+        singleton = cls.get_singleton()
+        if singleton:
+            cls.write([singleton], values)
         else:
-            singleton_id = super(ModelSingleton, self).create(values)
-        return singleton_id
+            singleton = super(ModelSingleton, cls).create(values)
+        return singleton
 
-    def read(self, ids, fields_names=None):
-        singleton_id = self.get_singleton_id()
-        if not singleton_id:
-            res = self.default_get(fields_names, with_rec_name=False)
+    @classmethod
+    def read(cls, ids, fields_names=None):
+        singleton = cls.get_singleton()
+        if not singleton:
+            res = cls.default_get(fields_names, with_rec_name=False)
             if not fields_names:
-                fields_names = (set(self._columns.keys()
-                    + self._inherit_fields.keys()))
+                fields_names = (set(cls._fields.keys()
+                    + cls._inherit_fields.keys()))
             for field_name in fields_names:
                 if field_name not in res:
                     res[field_name] = False
-            if not isinstance(ids, (int, long)):
-                res['id'] = ids[0]
-                res = [res]
-            else:
-                res['id'] = ids
-            return res
-        if isinstance(ids, (int, long)):
-            ids2 = singleton_id
-        else:
-            ids2 = [singleton_id]
-        res = super(ModelSingleton, self).read(ids2, fields_names=fields_names)
-        if isinstance(ids, (int, long)):
-            res['id'] = ids
-        else:
-            res[0]['id'] = ids[0]
+            res['id'] = ids[0]
+            return [res]
+        res = super(ModelSingleton, cls).read([singleton.id],
+            fields_names=fields_names)
+        res[0]['id'] = ids[0]
         return res
 
-    def write(self, ids, values):
-        singleton_id = self.get_singleton_id()
-        if not singleton_id:
-            return self.create(values)
-        if isinstance(ids, (int, long)):
-            ids = singleton_id
-        else:
-            ids = [singleton_id]
-        return super(ModelSingleton, self).write(ids, values)
+    @classmethod
+    def write(cls, records, values):
+        singleton = cls.get_singleton()
+        if not singleton:
+            return cls.create(values)
+        return super(ModelSingleton, cls).write([singleton], values)
 
-    def delete(self, ids):
-        singleton_id = self.get_singleton_id()
-        if not singleton_id:
-            return True
-        if isinstance(ids, (int, long)):
-            ids = singleton_id
-        else:
-            ids = [singleton_id]
-        return super(ModelSingleton, self).delete(ids)
+    @classmethod
+    def delete(cls, records):
+        singleton = cls.get_singleton()
+        if not singleton:
+            return
+        return super(ModelSingleton, cls).delete([singleton])
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, records, default=None):
         if default:
-            self.write(ids, default)
-        return ids
+            cls.write(records, default)
+        return records
 
-    def search(self, domain, offset=0, limit=None, order=None, count=False):
-        res = super(ModelSingleton, self).search(domain, offset=offset,
+    @classmethod
+    def search(cls, domain, offset=0, limit=None, order=None, count=False):
+        res = super(ModelSingleton, cls).search(domain, offset=offset,
                 limit=limit, order=order, count=count)
         if not res:
             if count:
                 return 1
-            return [1]
+            return [cls(1)]
         return res
 
-    def default_get(self, fields_names, with_rec_name=True):
+    @classmethod
+    def default_get(cls, fields_names, with_rec_name=True):
         if '_timestamp' in fields_names:
             fields_names = list(fields_names)
             fields_names.remove('_timestamp')
-        res = super(ModelSingleton, self).default_get(fields_names,
+        default = super(ModelSingleton, cls).default_get(fields_names,
                 with_rec_name=with_rec_name)
-        singleton_id = self.get_singleton_id()
-        if singleton_id:
+        singleton = cls.get_singleton()
+        if singleton:
             if with_rec_name:
                 fields_names = fields_names[:]
                 for field in fields_names[:]:
-                    if self._columns[field]._type in ('many2one',):
+                    if cls._fields[field]._type in ('many2one',):
                         fields_names.append(field + '.rec_name')
-            res = self.read(singleton_id, fields_names=fields_names)
-            for field in (x for x in res.keys() if x not in fields_names):
-                del res[field]
-        return res
+            default, = cls.read([singleton.id], fields_names=fields_names)
+            for field in (x for x in default.keys() if x not in fields_names):
+                del default[field]
+        return default
